/*!
  @file rx_fltk_window.cpp
	
  @brief FLTKɂEBhENX
 
  @author Makoto Fujisawa 
  @date   2011-08
*/


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_fltk_window.h"
#include "rx_atom_ini.h"


//-----------------------------------------------------------------------------
// ϐ
//-----------------------------------------------------------------------------
// ݒt@C
rxINI *g_pINI = new rxINI;

// ftHgǂݍ݃t@C
vector<string> g_vDefaultFiles;

extern double g_fSpacing;	//!< fvX}bṽTvOԊu
extern double g_fPrtRad;	//!< p[eBN̔a
extern double g_fZmax;		//!< ֊sƂȂfvX臒l
extern int g_iNfilter;		//!< fvXl̃tB^TCY
extern int g_iNiters;		//!< ֊s̔
extern int g_iNumPrts;		//!< p[eBN

//-----------------------------------------------------------------------------
// rxFlWindowNX̎
//-----------------------------------------------------------------------------

//! RXgN^
rxFlWindow::rxFlWindow(int w_, int h_, const char* title)
	: Fl_Double_Window(w_, h_, title), m_iWinX(100), m_iWinY(100), m_iWinW(w_), m_iWinH(h_)
{
	m_bFullScreen = 0;
	m_pStatusLabel = 0;
	resizable(this);

	int hs_menu = 20;	// j[o[̍
	int hs_gui = 120;	// EBWbgzü̍
	int hs_stat = 24;	// Xe[^Xo[̍

	int hor_margin = 5;	// }[W
	int ver_margin = 5;	// }[W

	int xs = hor_margin;

	begin();
	{
		// `̈
		int ys = hs_menu+ver_margin;
		int ws = w()-hor_margin*2;
		int hs = h()-(hs_menu+hs_gui+hs_stat+4*ver_margin);
		Fl_Group *g = new Fl_Group(xs, ys, ws, hs, 0);
		g->box(FL_NO_BOX);
		{
			m_pGLCanvas = new rxFlGLWindow(xs+2, ys+2, ws-4, hs-4, 0, this);
			m_pGLCanvas->mode(FL_RGB | FL_ALPHA | FL_DOUBLE | FL_DEPTH);
			m_pGLCanvas->box(FL_FLAT_BOX);
			m_pGLCanvas->align(FL_ALIGN_INSIDE | FL_ALIGN_CENTER);
			cout << ws << ", " << hs << endl;

			// D&D{bNX
			m_pDndBox = new rxFlDndBox(xs, ys, ws, hs, 0);
			m_pDndBox->callback(OnDnd_s, this);
		}
		g->end();
		Fl_Group::current()->resizable(g);
	}
	ReadConfig(RX_PROGRAM_NAME);
	{
		int count;

		// j[o[
		m_pMenuBar = new Fl_Menu_Bar(0, 0, w(), hs_menu, 0);

		// Filej[
		m_pMenuBar->add("File/Save FrameBuffer  ",	FL_CTRL+'s',			OnMenuFile_s, this); 
		m_pMenuBar->add("File/Save Depth Map",		FL_CTRL+FL_SHIFT+'s',	OnMenuFile_s, this); 
		m_pMenuBar->add("File/----------------"); 
		m_pMenuBar->add("File/Quit",				FL_Escape,				OnMenuFile_s, this); 

		// Drawj[
		count = 0;
		while(RX_DRAW_STR[2*count] != "-1"){
			string label = "Draw/"+RX_DRAW_STR[2*count]+"  ";
			string shortcut = RX_DRAW_STR[2*count+1];
			m_pMenuBar->add(RX_TO_CHAR(label), RX_TO_CHAR(shortcut), rxFlGLWindow::OnMenuDraw_s, m_pGLCanvas, FL_MENU_TOGGLE);
			count++;
		}

		// SSMj[
		m_pMenuBar->add("SSM/Generate",					"m",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas);
		m_pMenuBar->add("SSM/----------------"); 			  
		m_pMenuBar->add("SSM/Interactive Generation",	"V",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas, FL_MENU_TOGGLE);
		m_pMenuBar->add("SSM/GPU",						"g",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas, FL_MENU_TOGGLE);
		m_pMenuBar->add("SSM/Depth Filtering",			"a",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas, FL_MENU_TOGGLE);
		m_pMenuBar->add("SSM/Silhouette Filtering",		"b",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas, FL_MENU_TOGGLE);
		m_pMenuBar->add("SSM/----------------"); 
		m_pMenuBar->add("SSM/Reset Particles",			"^p", rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas);
		m_pMenuBar->add("SSM/Reset View",				"^v", rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas);
		m_pMenuBar->add("SSM/Reset Timer",				"^t", rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas);
		m_pMenuBar->add("SSM/----------------"); 
		m_pMenuBar->add("SSM/Selected Grid Info",		"g",  rxFlGLWindow::OnMenuSSM_s, m_pGLCanvas);

		// Polygonj[
		count = 0;
		while(RX_DRAW_POLY_STR[2*count] != "-1"){
			string label = "Polygon/"+RX_DRAW_POLY_STR[2*count]+"  ";
			string shortcut = RX_DRAW_POLY_STR[2*count+1];
			m_pMenuBar->add(RX_TO_CHAR(label), RX_TO_CHAR(shortcut), rxFlGLWindow::OnMenuDrawPolygon_s, m_pGLCanvas, FL_MENU_TOGGLE);
			count++;
		}
		
		// Depth Mapj[
		count = 0;
		while(RX_DRAW_DMAP_STR[2*count] != "-1"){
			string label = "Depth Map/"+RX_DRAW_DMAP_STR[2*count]+"  ";
			string shortcut = RX_DRAW_DMAP_STR[2*count+1];
			m_pMenuBar->add(RX_TO_CHAR(label), RX_TO_CHAR(shortcut), rxFlGLWindow::OnMenuDrawDepthMap_s, m_pGLCanvas, FL_MENU_TOGGLE);
			count++;
		}


		// OpenGLj[
		m_pMenuBar->add("OpenGL/Step",			' ', OnMenuOpenGL_s, this); 
		m_pMenuBar->add("OpenGL/Animation  ",	's', OnMenuOpenGL_s, this); 

		// Windowj[
		m_pMenuBar->add("Window/FullScreen  ",	FL_ALT+FL_Enter, OnMenuWindow_s, this, FL_MENU_TOGGLE); 

		// Helpj[
		m_pMenuBar->add("Help/Version", 0, OnMenuHelpVersion_s, this); 
	}
	{
		// GUÏ
		xs = hor_margin+10;
		int ys = h()-(hs_stat+ver_margin+hs_gui)+5;
		int ws = 60;
		int hs = 25;
		Fl_Boxtype boxtype = FL_FLAT_BOX;
				
		// Start/Stop{^
		m_pButtonStart = new Fl_Button(xs, ys, ws, hs, "Start/Stop");
		m_pButtonStart->callback(OnButtonStart_s, this);
		m_pButtonStart->down_box(boxtype);

		// Apply{^
		m_pButtonApply = new Fl_Button(xs, ys+1*(hs+5), ws, hs, "Apply");
		m_pButtonApply->callback(OnButtonApply_s, this);
		m_pButtonApply->down_box(boxtype);

		//
		// V~[Vp[^
		//
		xs += ws+5;
		ys = h()-(hs_stat+ver_margin+hs_gui)+5;
		hs = 21;

		Fl_Scroll* sg = new Fl_Scroll(xs, ys, 168, hs_gui-6, "SSM");
		{
			sg->box(FL_DOWN_BOX);
			sg->labelsize(12);
			sg->align(FL_ALIGN_TOP);

			xs += 70;
			ys += 15;

			Fl_Spinner *spin;
			spin = new Fl_Spinner(xs, ys, 87, 25, "Spacing ");
			spin->type(FL_INT_INPUT);
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(0);
			spin->maximum(32);
			spin->step(1);
			spin->value(g_fSpacing);

			spin = new Fl_Spinner(xs, ys+30, 87, 25, "Rad ");
			spin->type(FL_FLOAT_INPUT);
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(0);
			spin->maximum(1.0);
			spin->step(0.002);
			spin->value(g_fPrtRad);
		
			spin = new Fl_Spinner(xs, ys+60, 87, 25, "Zmax ");
			spin->type(FL_FLOAT_INPUT);
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(0);
			spin->maximum(10.0);
			spin->step(0.002);
			spin->value(g_fZmax);

			xs += 160;

			spin = new Fl_Spinner(xs, ys, 87, 25, "Nfilter ");
			spin->type(FL_INT_INPUT);
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(0);
			spin->maximum(30);
			spin->step(1);
			spin->value(g_iNfilter);
		
			spin = new Fl_Spinner(xs, ys+30, 87, 25, "Niters ");
			spin->type(FL_INT_INPUT );
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(0);
			spin->maximum(30);
			spin->step(1);
			spin->value(g_iNiters);
		
			spin = new Fl_Spinner(xs, ys+60, 87, 25, "Particles ");
			spin->type(FL_INT_INPUT);
			spin->callback(rxFlGLWindow::OnSpinSSM_s, m_pGLCanvas);
			spin->minimum(1);
			spin->maximum(100000);
			spin->step(100);
			spin->value(g_iNumPrts);
		
			sg->end();
			//Fl_Group::current()->resizable(sg);
		}
	}
	{
		// Xe[^Xo[(Fl_Box)
		int ys = h()-hs_stat;
		m_pBoxStatus = new Fl_Box(0, ys, w(), hs_stat, "status");
		m_pBoxStatus->box(FL_EMBOSSED_BOX);
		m_pBoxStatus->align(FL_ALIGN_INSIDE | FL_ALIGN_WRAP | FL_ALIGN_RIGHT);
		//m_pBoxStatus->color(color());
		m_pBoxStatus->labelfont(FL_HELVETICA_BOLD);
	}
	end();

	Fl::focus(m_pGLCanvas);
	resize(m_iWinX, m_iWinY, m_iWinW, m_iWinH);
	UpdateMenuState();

	show();
}

//! fXgN^
rxFlWindow::~rxFlWindow()
{
	WriteConfig(RX_PROGRAM_NAME);

	if(m_pMenuBar) delete m_pMenuBar;

	if(m_pGLCanvas) delete m_pGLCanvas;
	if(m_pDndBox) delete m_pDndBox;

	if(m_pButtonStart) delete m_pButtonStart;
	if(m_pButtonApply) delete m_pButtonApply;

	if(m_pStatusLabel) delete [] m_pStatusLabel;
	if(m_pBoxStatus) delete m_pBoxStatus;
}

/*!
 * `FbNtj[ڂ̍XV
 */
void rxFlWindow::UpdateMenuState(void)
{
	int current, count;

	// Draw - FL_MENU_TOGGLE
	current = m_pGLCanvas->m_iDraw;
	count = 0;
	while(RX_DRAW_STR[2*count] != "-1"){
		string label = "Draw/"+RX_DRAW_STR[2*count]+"  ";
		SetMenuItemState(m_pMenuBar, RX_TO_CHAR(label), ((0x01 << count) & current), 1);
		count++;
	}

	// SSM - FL_MENU_TOGGLE
	SetMenuItemState(m_pMenuBar, "SSM/Interactive Generation",	m_pGLCanvas->m_iViewMesh, 1);
	SetMenuItemState(m_pMenuBar, "SSM/GPU",						m_pGLCanvas->m_iUseGPU, 1);
	SetMenuItemState(m_pMenuBar, "SSM/Depth Filtering",			((m_pGLCanvas->m_iFiltering & 0x01) ? 1 : 0), 1);
	SetMenuItemState(m_pMenuBar, "SSM/Silhouette Filtering",	((m_pGLCanvas->m_iFiltering & 0x02) ? 1 : 0), 1);

	// Polygon - FL_MENU_TOGGLE
	current = m_pGLCanvas->m_iPolyDraw;
	count = 0;
	while(RX_DRAW_POLY_STR[2*count] != "-1"){
		string label = "Polygon/"+RX_DRAW_POLY_STR[2*count]+"  ";
		SetMenuItemState(m_pMenuBar, RX_TO_CHAR(label), ((0x01 << count) & current), 1);
		count++;
	}

	// Depth Map - FL_MENU_TOGGLE
	current = m_pGLCanvas->m_iDepthDraw;
	count = 0;
	while(RX_DRAW_DMAP_STR[2*count] != "-1"){
		string label = "Depth Map/"+RX_DRAW_DMAP_STR[2*count]+"  ";
		SetMenuItemState(m_pMenuBar, RX_TO_CHAR(label), ((0x01 << count) & current), 1);
		count++;
	}

	// Windowj[
	SetMenuItemState(m_pMenuBar, "Window/FullScreen  ", m_bFullScreen, 1);
}

/*!
 * j[:File -> OpeñR[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnMenuFile_s(Fl_Widget *widget, void* x)
{
	Fl_Menu_Bar *menubar = (Fl_Menu_Bar*)widget;
	char picked[80];
	menubar->item_pathname(picked, sizeof(picked)-1);	// j[

	string label = picked;
	string menu_name = "File/";
	label = label.substr(menu_name.size(), string::npos);

	if(label.find("Save Depth Map") == 0){
		((rxFlWindow*)x)->OnMenuFileSaveDepthMap();
	}
	else if(label.find("Save FrameBuffer") == 0){
		((rxFlWindow*)x)->OnMenuFileSaveFrame();
	}
	else if(label.find("Quit") == 0){
		((rxFlWindow*)x)->OnMenuFileQuit();
	}
}
void rxFlWindow::OnMenuFileSaveDepthMap(void)
{
	string filter = "Image Files|*.bmp;*.png|All Files|*.*";
	vector<string> fns;
	int n = ShowFileDialog(fns, "Save Depth Map", filter, false);

	for(int i = 0; i < n; ++i){
		string ext = GetExtension(fns[i]);
		m_pGLCanvas->SaveDepthMap(fns[i]);

		// 񂾃t@Ci[
		m_strFullPath = fns[i];
		m_strFileName = GetFileName(fns[i]);

		// t@CXe[^Xo[ɕ\
		SetStatusLabel(m_strFileName);
	}
}
void rxFlWindow::OnMenuFileSaveFrame(void)
{
	string filter = "Image Files|*.bmp;*.png|All Files|*.*";
	vector<string> fns;
	int n = ShowFileDialog(fns, "Save FrameBuffer", filter, false);

	for(int i = 0; i < n; ++i){
		string ext = GetExtension(fns[i]);
		m_pGLCanvas->SaveDisplay(fns[i]);

		// 񂾃t@Ci[
		m_strFullPath = fns[i];
		m_strFileName = GetFileName(fns[i]);

		// t@CXe[^Xo[ɕ\
		SetStatusLabel(m_strFileName);
	}
}
void rxFlWindow::OnMenuFileQuit(void)
{
	WriteConfig(RX_PROGRAM_NAME);
	exit(0);
}


/*!
 * Drawj[̃R[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnMenuOpenGL_s(Fl_Widget *widget, void* x)
{
	Fl_Menu_Bar *menubar = (Fl_Menu_Bar*)widget;
	char picked[80];
	menubar->item_pathname(picked, sizeof(picked)-1);	// j[

	string label = picked;
	string menu_name = "OpenGL/";
	label = label.substr(menu_name.size(), string::npos);
	
	((rxFlWindow*)x)->OnMenuOpenGL(label);
}
void rxFlWindow::OnMenuOpenGL(string label)
{
	if(label.find("Step") == 0){// Aj[V1Xebvs
		m_pGLCanvas->Idle();
	}
	else if(label.find("Animation") == 0){	// Aj[VON/OFF
		m_pGLCanvas->SwitchIdle(-1);
	}
}


/*!
 * Windowj[̃R[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnMenuWindow_s(Fl_Widget *widget, void* x)
{
	Fl_Menu_Bar *menubar = (Fl_Menu_Bar*)widget;
	char picked[80];
	menubar->item_pathname(picked, sizeof(picked)-1);	// j[

	string label = picked;
	string menu_name = "Window/";
	label = label.substr(menu_name.size(), string::npos);
	
	((rxFlWindow*)x)->OnMenuWindow(label);
}
void rxFlWindow::OnMenuWindow(string label)
{
	if(label.find("FullScreen") == 0){	// tXN[ON/OFF
		SwitchFullScreen();
	}
}


/*!
 * j[:Help -> VersioñR[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnMenuHelpVersion_s(Fl_Widget *widget, void* x)
{
	fl_message("OpenGL Application by FLTK\n  version 1.0");
}


/*!
 * rxFlDndBox̃R[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnDnd_s(Fl_Widget *widget, void* x)
{
	((rxFlWindow*)x)->OnDnd();
}
void rxFlWindow::OnDnd(void)
{
	if(m_pDndBox->Event() == FL_PASTE){
		int dnd_text_len = m_pDndBox->EventTextLength();
		string dnd_text = m_pDndBox->EventText();

		// eLXg\nŕ
		vector<string> fns;
		size_t pos0 = 0, pos1 = 0;
		do{
			pos1 = dnd_text.find('\n', pos0);
			string fn = dnd_text.substr(pos0, pos1-pos0);
			if(fn.empty()) break;

			fns.push_back(fn);
			pos0 = pos1+1;
		}while(pos1 != string::npos);

		int n = (int)fns.size();
		for(int i = 0; i < n; ++i){
			cout << "file" << i << " : " << fns[i] << endl;
		}

		if(n == 0) return;

		for(int i = 0; i < n; ++i){
			//Open(fns[i]);
		}
	}
}


/*!
 * Fl_ButtoñR[obN֐
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnButtonStart_s(Fl_Widget *widget, void* x)
{
	((rxFlWindow*)x)->OnButtonStart();
}
void rxFlWindow::OnButtonStart(void)
{
	m_pGLCanvas->SwitchIdle(-1);
}

/*!
 * Fl_ButtoñR[obN֐ - Apply{^
 * @param[in] widget EBWbg̐eNXIuWFNg
 * @param[in] x [U`ϐ
 */
void rxFlWindow::OnButtonApply_s(Fl_Widget *widget, void* x)
{
	((rxFlWindow*)x)->OnButtonApply(widget);
}
void rxFlWindow::OnButtonApply(Fl_Widget *widget)
{
	m_pGLCanvas->CreateSSM();
	m_pGLCanvas->redraw();
}




/*!
 * Xe[^Xo[ɕݒ
 * @param[in] label \
 */
void rxFlWindow::SetStatusLabel(const string &label)
{
	if(m_pStatusLabel) delete [] m_pStatusLabel;
	m_pStatusLabel = RX_TO_CHAR(label);
	m_pBoxStatus->label(m_pStatusLabel);
}



/*!
 * ݒt@Cǂݍ
 * @param[in] fn ݒt@C(gq)
 */
void rxFlWindow::ReadConfig(const string &fn)
{
	// AvP[VǗݒt@C
	if(!g_pINI) g_pINI = new rxINI();

	g_pINI->Set("window", "width",  &m_iWinW, m_iWinW);
	g_pINI->Set("window", "height", &m_iWinH, m_iWinH);
	g_pINI->Set("window", "pos_x",  &m_iWinX, m_iWinX);
	g_pINI->Set("window", "pos_y",  &m_iWinY, m_iWinY);

	if(!(g_pINI->Load(fn+".ini"))){
		cout << "Failed opening the " << fn << ".ini file!" << endl;
	}
}
/*!
 * ݒt@C
 * @param[in] fn ݒt@C(gq)
 */
void rxFlWindow::WriteConfig(const string &fn)
{
	m_iWinW = w();
	m_iWinH = h();
	m_iWinX = x();
	m_iWinY = y();
	if(g_pINI->Save(fn+".ini")){
		cout << "save : " << fn << ".ini" << endl;
	}
}

/*!
 * tXN[/EBhE\̐؂ւ
 */
void rxFlWindow::SwitchFullScreen(void)
{
	static int pos0[2] = { 0, 0 };
	static int win0[2] = { 500, 500 };
	if(m_bFullScreen){
		fullscreen_off(pos0[0], pos0[1], win0[0], win0[1]);
		m_bFullScreen = 0;
	}
	else{
		pos0[0] = x();
		pos0[1] = y();
		win0[0] = w();
		win0[1] = h();
		fullscreen();
		m_bFullScreen = 1;
	}
}

/*!
 * Cxgnh
 * @param[in] ev CxgID
 */
int rxFlWindow::handle(int ev)
{
	switch(ev){
	case FL_DND_ENTER:
	case FL_DND_RELEASE:
	case FL_DND_LEAVE:
	case FL_DND_DRAG:
	case FL_PASTE:
		return 1;

	case FL_PUSH:		// }EX{^_E
		m_pGLCanvas->Mouse(Fl::event_button(), 1, Fl::event_x(), Fl::event_y());
		break;
	case FL_RELEASE:	// }EX{^Abv
		m_pGLCanvas->Mouse(Fl::event_button(), 0, Fl::event_x(), Fl::event_y());
		break;
	case FL_DRAG:		// }EXhbO
		m_pGLCanvas->Motion(Fl::event_x(), Fl::event_y());
		break;
	case FL_MOVE:		// }EXړ
		m_pGLCanvas->PassiveMotion(Fl::event_x(), Fl::event_y());
		break;

	case FL_KEYBOARD:	// L[_E
		m_pGLCanvas->Keyboard(Fl::event_key(), Fl::event_x(), Fl::event_y());
		UpdateMenuState();
		break;

	case FL_SHORTCUT:	// O[oV[gJbg
		break;

	default:
		break;
	}

	return Fl_Window::handle(ev);
}