/*!
  @file rx_fltk_window.h
	
  @brief FLTKɂEBhENX
 
  @author Makoto Fujisawa 
  @date   2011-08
*/

#ifndef _RX_FLTK_WINDOW_H_
#define _RX_FLTK_WINDOW_H_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_fltk_glcanvas.h"

#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Spinner.H>
#include <FL/filename.H>		// t@C
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_File_Icon.H>


using namespace std;

//-----------------------------------------------------------------------------
// MARK:`/萔
//-----------------------------------------------------------------------------
const string RX_PROGRAM_NAME = "rx_fltk_ssm";


//-----------------------------------------------------------------------------
//! rxFlWindowNX - fltkɂEBhE
//-----------------------------------------------------------------------------
class rxFlWindow : public Fl_Double_Window
{
protected:
	// oϐ
	int m_iWinW;				//!< `EBhE̕
	int m_iWinH;				//!< `EBhE̍
	int m_iWinX;				//!< `EBhEʒux
	int m_iWinY;				//!< `EBhEʒuy

	// EBWbg
	Fl_Menu_Bar *m_pMenuBar;	//!< j[o[

	rxFlDndBox *m_pDndBox;		//!< D&D̈
	rxFlGLWindow *m_pGLCanvas;	//!< OpenGL`LpX

	Fl_Button *m_pButtonStart;	//!< Start/Stop{^
	Fl_Button *m_pButtonApply;	//!< Apply{^

	Fl_Box *m_pBoxStatus;		//!< Xe[^Xo[

	// t@C
	string m_strFileName;		//!< ǂݍ񂾃t@C
	string m_strFullPath;		//!< ǂݍ񂾃t@C(tpX)

	char *m_pStatusLabel;		//!< Xe[^Xo[

	bool m_bFullScreen;			//!< tXN[\
	int m_iIdle;				//!< ACh,^C}[̏

public:
	//! RXgN^
	rxFlWindow(int w, int h, const char* title);

	//! fXgN^
	~rxFlWindow();

public:
	// R[obN֐
	static void OnMenuFile_s(Fl_Widget *widget, void* x);
	inline void OnMenuFileSaveDepthMap(void);
	inline void OnMenuFileSaveFrame(void);
	inline void OnMenuFileQuit(void);
	static void OnMenuOpenGL_s(Fl_Widget *widget, void* x);
	inline void OnMenuOpenGL(string label);
	static void OnMenuWindow_s(Fl_Widget *widget, void* x);
	inline void OnMenuWindow(string label);
	static void OnMenuHelpVersion_s(Fl_Widget *widget, void* x);

	static void OnDnd_s(Fl_Widget *widget, void* x);
	inline void OnDnd(void);

	static void OnButtonStart_s(Fl_Widget *widget, void* x);
	inline void OnButtonStart(void);
	static void OnButtonApply_s(Fl_Widget *widget, void* x);
	inline void OnButtonApply(Fl_Widget *widget);

	// j[̍XV
	void UpdateMenuState(void);

	// Xe[^Xo[̕ύX
	void SetStatusLabel(const string &label);

	// tXN[ؑ
	void SwitchFullScreen(void);

	// t@Co
	void OpenImage(const string &fn);

	// ݒt@C
	void ReadConfig(const string &fn);
	void WriteConfig(const string &fn);

protected:
	int handle(int ev);
};





#endif // #ifdef _RX_FLTK_WINDOW_H_
