/*! @file rx_ps_curnel.cuh

	@brief CUDAɂSPH
 
	@author Makoto Fujisawa
	@date 2009-08
*/

#ifndef _RX_SSM_KERNEL_CUH_
#define _RX_SSM_KERNEL_CUH_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
//#include "cutil_math.h"
#include "vector_types.h"


//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
typedef unsigned int uint;
typedef unsigned char uchar;

#define FLOAT float
#define FLOAT3 float3

#define MAKE_FLOAT3 make_float3


// 1ubÑXbh(/)
#define BLOCK_SIZE 16

// 1ubN̍őXbh
#define THREAD_NUM 256


#define M_PI 3.141592653589793238462643383279502884197
#define M_2PI 6.283185307179586476925286766559005768394		// 2*PI


#define RX_MAX_FILTER_SIZE 10
#define RX_BINOMIALS_SIZE (RX_MAX_FILTER_SIZE+1)*(RX_MAX_FILTER_SIZE+1)

struct matrix4x4
{
	float4 e[4];
};

struct rxSsmParams
{
	float PrtRad;		//!< p[eBN̔a
	float4 PMV[4];		//!< esPƃfr[sMV|s
	float3 Tr;			//!< a̓eϊ
	uint W, H;			//!< `̈𑜓x
	float Spacing;		//!< fvX}bṽTvOԊu
	float Zmax;			//!< ֊sƂȂfvX臒l
	int Nfilter;		//!< fvXl̃tB^TCY
	int Niters;			//!< ֊s̔
	int Ngx, Ngy;		//!< bVpObh̉𑜓x
};

//! ObhGbW
struct rxSSEdgeG
{
	float3 x0, x1;		//!< [_WƃfvXl
	float depth;		//!< GbWfvXl
	int front_vertex;	//!< GbW_̃CfbNX
	float dx;			//!< fvXl[_GbW_܂ł̋
	int silhouette;
};


//! bVpObh
struct rxSSGridG
{
	int i, j;
	int node_vrts[4];	//!< m[h_CfbNX
	int num_nv;			//!< m[h_
	int edge_vrts[4];	//!< GbW_(front vertex)
	int num_ev;			//!< GbW_(front vertex)
	int back_vrts[6];	//!< GbW_(back vertex, back-2 vertex)
	int num_bv;			//!< GbW_(back vertex)

	float node_depth[4];	//!< m[h̃fvXl
	int vrot;

	int table_index0;	//!< fobOp:bV̂߂̃CfbNXl
	int table_index1;	//!< fobOp:bV̂߂̃CfbNXl
	int mesh_num;		//!< fobOp:bV
	int mesh[6];		//!< fobOp:bVCfbNX
	int back2;			//!< fobOp
	int v[14];
};

//! pbN邽߂̃f[^\

template<class T> 
struct rxVPack
{
	T* dPos;
	T* dCompactedPos;
	uint* dOcc;
	uint* dOccScan;

	rxVPack()
	{
		dPos = 0;
		dCompactedPos = 0;
		dOcc = 0;
		dOccScan = 0;
	}
};

typedef rxVPack<float> rxVPackf;
typedef rxVPack<rxSSEdgeG> rxVPacke;

struct rxVrtAdd
{
	int num;
	int layer;
	int edge[2];
	float3 vrts[2];
};



#endif // _RX_SSM_KERNEL_CUH_
